#include <unistd.h>
#include <memory>
#include <iostream>
#include "rclcpp/rclcpp.hpp"
#include "std_msgs/msg/string.hpp"
#include "nav680_ros2/msg/nav.hpp"
#include <iomanip>

rclcpp::Node::SharedPtr nh = nullptr;
using namespace std;

// uint32 itow
// uint16 week_num
// int32 lat
// int32 lon
// int32 hgt
// float32 vn
// float32 ve
// float32 vd
// float32 roll
// float32 pitch
// float32 yaw
// float32 rtk_yaw
// float32 wheel_angle
// float32[7] imu
// uint8 fix_type
// uint8 sv_num
// uint8 diff_age
// uint8 heading_type
// uint16 pos_acc
// uint16 status


void topic_callback(const nav680_ros2::msg::Nav::SharedPtr msg)
{

	cout << "header:" << "\n";
	cout << "	" << "stamp:"<< "\n";
	cout << "	  " << "secs:" << msg->header.stamp.sec<< "\n";
	cout << "	  " << "nanosecs:" << msg->header.stamp.nanosec << "\n";
	cout << "	" << "frame_id:" << msg->header.frame_id << "\n" ;

	cout << "	" << "itow: " << fixed << setprecision(18) << msg->itow << "\n";
	cout << "	" << "week_num: " << fixed << setprecision(18) << msg->week_num << "\n";
	cout << "	" << "lat: " << fixed << setprecision(18) << msg->lat << "\n"; 
	cout << "	" << "lon: " << fixed << setprecision(18) << msg->lon << "\n";
	cout << "	" << "hgt: " << fixed << setprecision(18) << msg->hgt << "\n"; 
	cout << "	" << "vn: " << fixed << setprecision(18) << msg->vn << "\n"; 
	cout << "	" << "ve: " << fixed << setprecision(18) << msg->ve << "\n"; 
	cout << "	" << "vd: " << fixed << setprecision(18) << msg->vd << "\n"; 
	cout << "	" << "roll: " << fixed << setprecision(18) << msg->roll << "\n";
	cout << "	" << "pitch: " << fixed << setprecision(18) << msg->pitch << "\n"; 
	cout << "	" << "yaw: " << fixed << setprecision(18) << msg->yaw << "\n"; 
	cout << "	" << "rtk_yaw: " << fixed << setprecision(18) << msg->rtk_yaw << "\n";
	cout << "	" << "wheel_angle: " << fixed << setprecision(18) << msg->wheel_angle << "\n";
	cout << "	" << "fix_type: " << fixed << setprecision(18) << msg->fix_type << "\n";
	cout << "	" << "heading_type: " << fixed << setprecision(18) << msg->heading_type << "\n"; 
	cout << "	" << "pos_acc: " << fixed << setprecision(18) << msg->pos_acc << "\n"; 
	cout << "	" << "status: " << fixed << setprecision(18) << msg->status << "\n";   

	cout  << "imu:" << "\n";
	cout  << "	" << "acc_x: " << fixed << setprecision(18) << msg->imu[0] << "\n" ;
	cout  << "	" << "acc_y: " << fixed << setprecision(18) << msg->imu[1] << "\n" ;
	cout  << "	" << "acc_z: " << fixed << setprecision(18) << msg->imu[2] << "\n" ;
	cout  << "	" << "gyro_x: " << fixed << setprecision(18) << msg->imu[3] << "\n" ;
	cout  << "	" << "gyro_y: " << fixed << setprecision(18) << msg->imu[4] << "\n" ;
	cout  << "	" << "gyro_z: " << fixed << setprecision(18) << msg->imu[5] << "\n" ;
	cout  << "	" << "temp: " << fixed << setprecision(4) << msg->imu[6] << "\n"<< "---" << endl; ;
 }



int main(int argc,const char* argv[])
{
	rclcpp::init(argc, argv);
	nh = std::make_shared<rclcpp::Node>("nav_pub1");
	rclcpp::Subscription<nav680_ros2::msg::Nav>::SharedPtr nav_pub1 ;
	nav_pub1 = nh->create_subscription<nav680_ros2::msg::Nav>("nav680_data", 10,topic_callback);
	rclcpp::spin(nh);
	rclcpp::shutdown();

	return 0;
}
