
#include "can_parse.h"
#include <linux/can.h>
#include <linux/can/raw.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <unistd.h>
#include <cstring>
#include <iostream>
#include <fcntl.h>
#define CAN_INTERFACE_NAME "can0"
void can_send_data(uint32_t id,uint8_t *data, uint32_t length);
ros::Publisher IMU_pub;

static int frame_rate;
static int frame_count;

static uint8_t buf[2048];

void timer(int sig)
{
	if(SIGALRM == sig)
	{
		frame_rate = frame_count;
		frame_count = 0;
		alarm(1);
	}
}

int socket_fd;


int main(int argc, char** argv)
{
	int rev = 0;
	ros::init(argc, argv, "can_imu");
	ros::NodeHandle n;

	IMU_pub = n.advertise<sensor_msgs::Imu>("/IMU_data", 20);

     socket_fd = socket(PF_CAN, SOCK_RAW, CAN_RAW);
    if (socket_fd < 0) {
        perror("创建socket失败");
        return 1;
    }

    struct sockaddr_can address;
    struct ifreq ifr;

    strcpy(ifr.ifr_name, CAN_INTERFACE_NAME);
    ioctl(socket_fd, SIOCGIFINDEX, &ifr);

    address.can_family = AF_CAN;
    address.can_ifindex = ifr.ifr_ifindex;

    if (bind(socket_fd, (struct sockaddr *)&address, sizeof(address)) < 0) {
        perror("绑定socket失败");
        return 1;
    }

    int flags = fcntl(socket_fd, F_GETFL, 0);
    fcntl(socket_fd, F_SETFL, flags | O_NONBLOCK);
   struct can_frame frame;


	signal(SIGALRM,timer);


	alarm(1);
	 
	ros::Rate loop_rate(100);

	Send_CMD_LONG(3,1,0,0,0,0,0); //获取AHRS数据流
	for (int i = 0; i < 10; i++)
   can_send_data(0x64,(uint8_t *)&data_cmd_long,sizeof(data_cmd_long));
   


     
	while(ros::ok())
	{
	
         while(read(socket_fd, &frame, sizeof(struct can_frame))>=1)
         {
            if(frame.can_id==0xc8)
            {
               for (int i = 0; i < frame.can_dlc; i++) 
               imu_rx(frame.data[i]);
            }

         }
 
 
		loop_rate.sleep();
	}

    close(socket_fd);
	return 0;
}


void can_send_data(uint32_t id,uint8_t *data, uint32_t length)
{
    struct can_frame frame;

    // 拼包发送
    for (int i = 0; i < length; i += 8) {
        int remainingBytes = length - i; // 剩余要发送的字节数
        int dataLen = (remainingBytes < 8) ? remainingBytes : 8;

        frame.can_id = id; // 示例CAN ID
        frame.can_dlc = dataLen;

        memcpy(frame.data, &data[i], dataLen);

        if (write(socket_fd, &frame, sizeof(struct can_frame)) != sizeof(struct can_frame)) {
            // perror("Write_error1111");

        }

     usleep(200);

}

}


