# NAV619_ROS串口例程

本文档介绍如何在ROS下读取nav619的数据，并提供了c++语言例程代码，通过执行ROS命令，运行相应的节点，就可以看到打印到终端上的信息。

* 测试环境：Ubuntu20.04

* ROS版本：ROS_noetic


* 测试设备：nav619

## 安装 ROS serial 软件包，

安装 ROS serial 软件包，本例程依赖 ROS 提供的 serial 包实现串口通信。
首先执行如下命令，下载安装 serial 软件包：
sudo apt install ros-noetic-serial


如果出现报错，如pkg was interrupted, you must manually run 'sudo dpkg --configure -a' to correct the problem，则进行以下命令解决：
sudo dpkg --configure -a
sudo apt update


## 安装USB-UART驱动

Ubuntu 默认不需要安装串口驱动。将USB线连接到电脑上时，会自动识别设备。识别成功后，会在dev目录下出现一个对应的设备:ttyUSBx

检查USB-UART设备是否被Ubantu识别：

1. 打开终端，输入`ls /dev`,先查看已经存在的串口设备。
2. 查看是否已经存在  ttyUSBx 这个设备文件，便于确认对应的端口号。
4. 接下来插入USB线，连接调试板，然后再次执行`ls /dev`。 dev目录下多了一个设备`ttyUSB0`：

```shell
linux@ubuntu:~$ ls /dev
.....
hpet             net           tty11     tty4   ttyS0      ttyUSB0    vhost-vsock
hugepages        null          tty12     tty40  ttyS1      udmabuf  vmci
......
```

4.打开USB设备的可执行权限：

```shell
   $ sudo chmod 777 /dev/ttyUSB0
```



## 编译代码
```shell
//进入工作文件夹
cd nav619_ros1
//编译
catkin_make

//执⾏载入工作空间的环境设置
source devel/setup.bash
```


###  查看 IMU 数据

1. 打开一个终端，执行：
```shell
roscore
```
2.回到nav619_ros1⽂件夹下,在新窗口下输入以下命令:
```shell
 //执⾏载入工作空间的环境设置
source devel/setup.bash

执⾏启动 rosrun,打开串口
rosrun forsense_ins forsense_ins
```

3. 打开新的终端,输入以下命令可获取数据:
```shell
//再次执行执⾏载入工作空间的环境设置:
source devel/setup.bash

//列出当前运行系统中所有活跃的话题
rostopic list

输⼊命令查看组合导航数据
rostopic echo /nav619Data
```





